scala.collection.parallel

# ParIterableLike

#### trait ParIterableLike[+T, +Repr <: ParIterable[T], +Sequential <: Iterable[T] with IterableLike[T, Sequential]] extends GenIterableLike[T, Repr] with CustomParallelizable[T, Repr] with Parallel with HasNewCombiner[T, Repr]

A template trait for parallel collections of type `ParIterable[T]`.

This is a base trait for Scala parallel collections. It defines behaviour common to all parallel collections. Concrete parallel collections should inherit this trait and `ParIterable` if they want to define specific combiner factories.

Parallel operations are implemented with divide and conquer style algorithms that parallelize well. The basic idea is to split the collection into smaller parts until they are small enough to be operated on sequentially.

All of the parallel operations are implemented as tasks within this trait. Tasks rely on the concept of splitters, which extend iterators. Every parallel collection defines:

        def splitter: IterableSplitter[T]

which returns an instance of `IterableSplitter[T]`, which is a subtype of `Splitter[T]`. Parallel iterators have a method `remaining` to check the remaining number of elements, and method `split` which is defined by splitters. Method `split` divides the splitters iterate over into disjunct subsets:

        def split: Seq[Splitter]

which splits the splitter into a sequence of disjunct subsplitters. This is typically a very fast operation which simply creates wrappers around the receiver collection. This can be repeated recursively.

Method `newCombiner` produces a new combiner. Combiners are an extension of builders. They provide a method `combine` which combines two combiners and returns a combiner containing elements of both combiners. This method can be implemented by aggressively copying all the elements into the new combiner or by lazily binding their results. It is recommended to avoid copying all of the elements for performance reasons, although that cost might be negligible depending on the use case. Standard parallel collection combiners avoid copying when merging results, relying either on a two-step lazy construction or specific data-structure properties.

Methods:

        def seq: Sequential
        def par: Repr

produce the sequential or parallel implementation of the collection, respectively. Method `par` just returns a reference to this parallel collection. Method `seq` is efficient - it will not copy the elements. Instead, it will create a sequential version of the collection using the same underlying data structure. Note that this is not the case for sequential collections in general - they may copy the elements and produce a different underlying data structure.

The combination of methods `toMap`, `toSeq` or `toSet` along with `par` and `seq` is a flexible way to change between different collection types.

The method:

        def threshold(sz: Int, p: Int): Int

provides an estimate on the minimum number of elements the collection has before the splitting stops and depends on the number of elements in the collection. A rule of the thumb is the number of elements divided by 8 times the parallelism level. This method may be overridden in concrete implementations if necessary.

Since this trait extends the `Iterable` trait, methods like `size` must also be implemented in concrete collections, while `iterator` forwards to `splitter` by default.

Each parallel collection is bound to a specific fork/join pool, on which dormant worker threads are kept. The fork/join pool contains other information such as the parallelism level, that is, the number of processors used. When a collection is created, it is assigned the default fork/join pool found in the `scala.parallel` package object.

Parallel collections are not necessarily ordered in terms of the `foreach` operation (see `Traversable`). Parallel sequences have a well defined order for iterators - creating an iterator and traversing the elements linearly will always yield the same order. However, bulk operations such as `foreach`, `map` or `filter` always occur in undefined orders for all parallel collections.

Existing parallel collection implementations provide strict parallel iterators. Strict parallel iterators are aware of the number of elements they have yet to traverse. It's also possible to provide non-strict parallel iterators, which do not know the number of elements remaining. To do this, the new collection implementation must override `isStrictSplitterCollection` to `false`. This will make some operations unavailable.

To create a new parallel collection, extend the `ParIterable` trait, and implement `size`, `parallelIterator`, `newCombiner` and `seq`. Having an implicit combiner factory requires extending this trait in addition, as well as providing a companion object, as with regular collections.

Method `size` is implemented as a constant time operation for parallel collections, and parallel collection operations rely on this assumption.

The higher-order functions passed to certain operations may contain side-effects. Since implementations of bulk operations may not be sequential, this means that side-effects may not be predictable and may produce data-races, deadlocks or invalidation of state if care is not taken. It is up to the programmer to either avoid using side-effects or to use some form of synchronization when accessing mutable data.

T

  the element type of the collection

Repr

  the type of the actual collection containing the elements

Self Type
  ParIterableLike[T, Repr, Sequential]
Source
  ParIterableLike.scala

Linear Supertypes
HasNewCombiner[T, Repr], Parallel, CustomParallelizable[T, Repr], GenIterableLike[T, Repr], GenTraversableLike[T, Repr], Parallelizable[T, Repr], GenTraversableOnce[T], AnyRef, Any
Known Subclasses
Appended, Appended, Forced, Forced, Mapped, Mapped, ParArray, ParHashMap, ParHashMap, ParHashSet, ParHashSet, ParIterable, ParIterable, ParIterable, ParIterableView, ParIterableViewLike, ParMap, ParMap, ParMap, ParMapLike, ParMapLike, ParRange, ParSeq, ParSeq, ParSeq, ParSeqLike, ParSeqView, ParSeqViewLike, ParSet, ParSet, ParSet, ParSetLike, ParSetLike, ParVector, Patched, Prepended, Reversed, Sliced, Sliced, Transformed, Transformed, Zipped, Zipped, ZippedAll, ZippedAll
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. ParIterableLike
2. HasNewCombiner
3. Parallel
4. CustomParallelizable
5. GenIterableLike
6. GenTraversableLike
7. Parallelizable
8. GenTraversableOnce
9. AnyRef
10. Any

Visibility

1. Public
2. All

### Type Members

1. #### trait Accessor[R, Tp] extends StrictSplitterCheckTask[R, Tp]

   Standard accessor task that iterates over the elements of the collection.

2. #### class Aggregate[S] extends Accessor[S, Aggregate[S]]

   Attributes
     protected[this]

3. #### trait BuilderOps[Elem, To] extends AnyRef

4. #### class Collect[S, That] extends Transformer[Combiner[S, That], Collect[S, That]]

   Attributes
     protected[this]

5. #### abstract class Composite[FR, SR, R, First <: ParIterableLike.this.StrictSplitterCheckTask[FR, _], Second <: ParIterableLike.this.StrictSplitterCheckTask[SR, _]] extends NonDivisibleTask[R, Composite[FR, SR, R, First, Second]]

   Attributes
     protected[this]

6. #### class Copy[U >: T, That] extends Transformer[Combiner[U, That], Copy[U, That]]

   Attributes
     protected

7. #### class CopyToArray[U >: T, This >: Repr] extends Accessor[Unit, CopyToArray[U, This]]

   Attributes
     protected[this]

8. #### class Count extends Accessor[Int, Count]

   Attributes
     protected[this]

9. #### class CreateScanTree[U >: T] extends Transformer[ScanTree[U], CreateScanTree[U]]

   Attributes
     protected[this]

10. #### class Drop[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Drop[U, This]]

    Attributes
      protected[this]

11. #### class Exists extends Accessor[Boolean, Exists]

    Attributes
      protected[this]

12. #### class Filter[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Filter[U, This]]

    Attributes
      protected[this]

13. #### class FilterNot[U >: T, This >: Repr] extends Transformer[Combiner[U, This], FilterNot[U, This]]

    Attributes
      protected[this]

14. #### class Find[U >: T] extends Accessor[Option[U], Find[U]]

    Attributes
      protected[this]

15. #### class FlatMap[S, That] extends Transformer[Combiner[S, That], FlatMap[S, That]]

    Attributes
      protected[this]

16. #### class Fold[U >: T] extends Accessor[U, Fold[U]]

    Attributes
      protected[this]

17. #### class Forall extends Accessor[Boolean, Forall]

    Attributes
      protected[this]

18. #### class Foreach[S] extends Accessor[Unit, Foreach[S]]

    Attributes
      protected[this]

19. #### class FromScanTree[U >: T, That] extends StrictSplitterCheckTask[Combiner[U, That], FromScanTree[U, That]]

    Attributes
      protected[this]

20. #### class GroupBy[K, U >: T] extends Transformer[HashMapCombiner[K, U], GroupBy[K, U]]

    Attributes
      protected[this]

21. #### class Map[S, That] extends Transformer[Combiner[S, That], Map[S, That]]

    Attributes
      protected[this]

22. #### class Max[U >: T] extends Accessor[Option[U], Max[U]]

    Attributes
      protected[this]

23. #### class Min[U >: T] extends Accessor[Option[U], Min[U]]

    Attributes
      protected[this]

24. #### trait NonDivisible[R] extends NonDivisibleTask[R, NonDivisible[R]]

    Attributes
      protected[this]

25. #### trait NonDivisibleTask[R, Tp] extends StrictSplitterCheckTask[R, Tp]

    Attributes
      protected[this]

26. #### abstract class ParComposite[FR, SR, R, First <: ParIterableLike.this.StrictSplitterCheckTask[FR, _], Second <: ParIterableLike.this.StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Performs two tasks in parallel, and waits for both to finish.

27. #### trait ParIterator extends IterableSplitter[T]

    Parallel iterators are split iterators that have additional accessor and transformer methods defined in terms of methods `next` and `hasNext`.

28. #### class Partition[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Partition[U, This]]

    Attributes
      protected[this]

29. #### class Product[U >: T] extends Accessor[U, Product[U]]

    Attributes
      protected[this]

30. #### class Reduce[U >: T] extends Accessor[Option[U], Reduce[U]]

    Attributes
      protected[this]

31. #### abstract class ResultMapping[R, Tp, R1] extends NonDivisibleTask[R1, ResultMapping[R, Tp, R1]]

    Attributes
      protected[this]

32. #### type SSCTask[R, Tp] = StrictSplitterCheckTask[R, Tp]

33. #### case class ScanLeaf[U >: T](pit: IterableSplitter[U], op: (U, U) ⇒ U, from: Int, len: Int, prev: Option[ScanLeaf[U]], acc: U) extends ScanTree[U] with Product with Serializable

    Attributes
      protected[this]

34. #### case class ScanNode[U >: T](left: ScanTree[U], right: ScanTree[U]) extends ScanTree[U] with Product with Serializable

    Attributes
      protected[this]

35. #### trait ScanTree[U >: T] extends AnyRef

    Attributes
      protected[this]

36. #### abstract class SeqComposite[FR, SR, R, First <: ParIterableLike.this.StrictSplitterCheckTask[FR, _], Second <: ParIterableLike.this.StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Sequentially performs one task after another.

37. #### trait SignalContextPassingIterator[+IterRepr <: ParIterator] extends ParIterator

    A stackable modification that ensures signal contexts get passed along the iterators.

38. #### trait SignallingOps[PI <: DelegatedSignalling] extends AnyRef

39. #### class Slice[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Slice[U, This]]

    Attributes
      protected[this]

40. #### class Span[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Span[U, This]]

    Attributes
      protected[this]

41. #### class SplitAt[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), SplitAt[U, This]]

    Attributes
      protected[this]

42. #### trait StrictSplitterCheckTask[R, Tp] extends Task[R, Tp]

    Attributes
      protected

43. #### class Sum[U >: T] extends Accessor[U, Sum[U]]

    Attributes
      protected[this]

44. #### class Take[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Take[U, This]]

    Attributes
      protected[this]

45. #### class TakeWhile[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Boolean), TakeWhile[U, This]]

    Attributes
      protected[this]

46. #### trait TaskOps[R, Tp] extends AnyRef

47. #### class ToParCollection[U >: T, That] extends Transformer[Combiner[U, That], ToParCollection[U, That]]

    Attributes
      protected[this]

48. #### class ToParMap[K, V, That] extends Transformer[Combiner[(K, V), That], ToParMap[K, V, That]]

    Attributes
      protected[this]

49. #### trait Transformer[R, Tp] extends Accessor[R, Tp]

    Attributes
      protected

50. #### class Zip[U >: T, S, That] extends Transformer[Combiner[(U, S), That], Zip[U, S, That]]

    Attributes
      protected[this]

51. #### class ZipAll[U >: T, S, That] extends Transformer[Combiner[(U, S), That], ZipAll[U, S, That]]

    Attributes
      protected[this]

### Abstract Value Members

1. #### abstract def newCombiner: Combiner[T, Repr]

   Attributes
     protected[this]
   Definition Classes
     HasNewCombiner

2. #### abstract def seq: Sequential

   Definition Classes
     ParIterableLike → Parallelizable → GenTraversableOnce

3. #### abstract def size: Int

   The size of this general iterable collection .

   The size of this general iterable collection .

   Note: will not terminate for infinite-sized collections.

   returns

     the number of elements in this general iterable collection .

   Definition Classes
     GenTraversableLike → GenTraversableOnce

4. #### abstract def splitter: IterableSplitter[T]

   Creates a new parallel iterator used to traverse the elements of this parallel collection.

   Creates a new parallel iterator used to traverse the elements of this parallel collection. This iterator is more specific than the iterator of the returned by `iterator`, and augmented with additional accessor and transformer methods.

   returns

     a parallel iterator

   Attributes
     protected[parallel]

5. #### abstract def stringPrefix: String

   Defines the prefix of this object's `toString` representation.

   Defines the prefix of this object's `toString` representation.

   returns

     a string representation which starts the result of `toString` applied to this general iterable collection . By default the string prefix is the simple name of the collection class general iterable collection .

   Definition Classes
     GenTraversableLike

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### abstract def ++[B](that: GenTraversableOnce[B]): GenIterable[B]

   [use case] Returns a new general iterable collection containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new general iterable collection containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the general iterable collection is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this general iterable collection followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

5. #### def ++[U >: T, That](that: GenTraversableOnce[U])(implicit bf: CanBuildFrom[Repr, U, That]): That

   Returns a new general iterable collection containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new general iterable collection containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the general iterable collection is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this general iterable collection followed by all elements of `that`.

   Definition Classes
     ParIterableLike → GenTraversableLike

6. #### def /:[S](z: S)(op: (S, T) ⇒ S): S

   Applies a binary operator to a start value and all elements of this general iterable collection , going left to right.

   Applies a binary operator to a start value and all elements of this general iterable collection , going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (5 /: a)(_+_)
            b: Int = 15

            scala> val c = (5 /: a)((x,y) => x + y)
            c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this general iterable collection , going left to right with the start value `z` on the left:

                     op(...op(op(z, x1), x2), ..., xn)

     where `x1, ..., xn` are the elements of this general iterable collection .

   Definition Classes
     ParIterableLike → GenTraversableOnce

7. #### def /:\[A1 >: T](z: A1)(op: (A1, A1) ⇒ A1): A1

   A syntactic sugar for out of order folding.

   A syntactic sugar for out of order folding. See `fold`.

   Example:

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (a /:\ 5)(_+_)
            b: Int = 15

   Definition Classes
     GenTraversableOnce

8. #### def :\[S](z: S)(op: (T, S) ⇒ S): S

   Applies a binary operator to all elements of this general iterable collection and a start value, going right to left.

   Applies a binary operator to all elements of this general iterable collection and a start value, going right to left.

   Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (a :\ 5)(_+_)
            b: Int = 15

            scala> val c = (a :\ 5)((x,y) => x + y)
            c: Int = 15

   z

     the start value

   op

     the binary operator

   returns

     the result of inserting `op` between consecutive elements of this general iterable collection , going right to left with the start value `z` on the right:

                     op(x1, op(x2, ... op(xn, z)...))

     where `x1, ..., xn` are the elements of this general iterable collection .

   Definition Classes
     ParIterableLike → GenTraversableOnce

9. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

10. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

11. #### def aggregate[S](z: S)(seqop: (S, T) ⇒ S, combop: (S, S) ⇒ S): S

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    S

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      ParIterableLike → GenTraversableOnce

12. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

13. #### def bf2seq[S, That](bf: CanBuildFrom[Repr, S, That]): CanBuildFrom[Sequential, S, That]

    Attributes
      protected[this]

14. #### implicit def builder2ops[Elem, To](cb: Builder[Elem, To]): BuilderOps[Elem, To]

    Attributes
      protected

15. #### def canEqual(other: Any): Boolean

16. #### def cbfactory: () ⇒ Combiner[T, Repr]

    Attributes
      protected[this]

17. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

18. #### abstract def collect[B](pf: PartialFunction[T, B]): GenIterable[B]

    [use case] Builds a new collection by applying a partial function to all elements of this general iterable collection

    [use case]

    Builds a new collection by applying a partial function to all elements of this general iterable collection

    on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the general iterable collection .

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

19. #### def collect[S, That](pf: PartialFunction[T, S])(implicit bf: CanBuildFrom[Repr, S, That]): That

    Builds a new collection by applying a partial function to all elements of this general iterable collection

    Builds a new collection by applying a partial function to all elements of this general iterable collection

    on which the function is defined.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the general iterable collection .

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

20. #### def copyToArray[U >: T](xs: Array[U], start: Int, len: Int): Unit

    Definition Classes
      ParIterableLike → GenTraversableOnce

21. #### abstract def copyToArray(xs: Array[T], start: Int): Unit

    [use case] Copies values of this general iterable collection to an array.

    [use case]

    Copies values of this general iterable collection to an array. Fills the given array `xs` with values of this general iterable collection , beginning at index `start`. Copying will stop once either the end of the current general iterable collection is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

22. #### def copyToArray[U >: T](xs: Array[U], start: Int): Unit

    Copies values of this general iterable collection to an array.

    Copies values of this general iterable collection to an array. Fills the given array `xs` with values of this general iterable collection , beginning at index `start`. Copying will stop once either the end of the current general iterable collection is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      ParIterableLike → GenTraversableOnce

23. #### abstract def copyToArray(xs: Array[T]): Unit

    [use case] Copies values of this general iterable collection to an array.

    [use case]

    Copies values of this general iterable collection to an array. Fills the given array `xs` with values of this general iterable collection . Copying will stop once either the end of the current general iterable collection is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

24. #### def copyToArray[U >: T](xs: Array[U]): Unit

    Copies values of this general iterable collection to an array.

    Copies values of this general iterable collection to an array. Fills the given array `xs` with values of this general iterable collection . Copying will stop once either the end of the current general iterable collection is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    Definition Classes
      ParIterableLike → GenTraversableOnce

25. #### def count(p: (T) ⇒ Boolean): Int

    Counts the number of elements in the general iterable collection which satisfy a predicate.

    Counts the number of elements in the general iterable collection which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

26. #### def debugBuffer: ArrayBuffer[String]

27. #### implicit def delegatedSignalling2ops[PI <: DelegatedSignalling](it: PI): SignallingOps[PI]

    Attributes
      protected

28. #### def drop(n: Int): Repr

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this general iterable collection .

    returns

      a general iterable collection consisting of all elements of this general iterable collection except the first `n` ones, or else the empty general iterable collection , if this general iterable collection has less than `n` elements.

    Definition Classes
      ParIterableLike → GenTraversableLike

29. #### def dropWhile(pred: (T) ⇒ Boolean): Repr

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

    pred

      the predicate used to test the elements

    returns

      a collection composed of all the elements after the longest prefix of elements in this general iterable collection that satisfy the predicate `pred`

    Definition Classes
      ParIterableLike → GenTraversableLike

30. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

31. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

32. #### def exists(pred: (T) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some element of this general iterable collection .

    Tests whether a predicate holds for some element of this general iterable collection .

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    returns

      true if `p` holds for some element, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

33. #### def filter(pred: (T) ⇒ Boolean): Repr

    Selects all elements of this general iterable collection which satisfy a predicate.

    Selects all elements of this general iterable collection which satisfy a predicate.

    returns

      a new general iterable collection consisting of all elements of this general iterable collection that satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

34. #### def filterNot(pred: (T) ⇒ Boolean): Repr

    Selects all elements of this general iterable collection which do not satisfy a predicate.

    Selects all elements of this general iterable collection which do not satisfy a predicate.

    returns

      a new general iterable collection consisting of all elements of this general iterable collection that do not satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

35. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

36. #### def find(pred: (T) ⇒ Boolean): Option[T]

    Finds some element in the collection for which the predicate holds, if such an element exists.

    Finds some element in the collection for which the predicate holds, if such an element exists. The element may not necessarily be the first such element in the iteration order.

    If there are multiple elements obeying the predicate, the choice is nondeterministic.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    returns

      an option value with the element if such an element exists, or `None` otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

37. #### abstract def flatMap[B](f: (T) ⇒ GenTraversableOnce[B]): GenIterable[B]

    [use case] Builds a new collection by applying a function to all elements of this general iterable collection

    [use case]

    Builds a new collection by applying a function to all elements of this general iterable collection

    and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this general iterable collection and concatenating the results.

    Definition Classes
      GenTraversableLike

38. #### def flatMap[S, That](f: (T) ⇒ GenTraversableOnce[S])(implicit bf: CanBuildFrom[Repr, S, That]): That

    Builds a new collection by applying a function to all elements of this general iterable collection

    Builds a new collection by applying a function to all elements of this general iterable collection

    and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of general iterable collection . This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this general iterable collection and concatenating the results.

    Definition Classes
      ParIterableLike → GenTraversableLike

39. #### def fold[U >: T](z: U)(op: (U, U) ⇒ U): U

    Folds the elements of this sequence using the specified associative binary operator.

    Folds the elements of this sequence using the specified associative binary operator. The order in which the elements are reduced is unspecified and may be nondeterministic.

    Note this method has a different signature than the `foldLeft` and `foldRight` methods of the trait `Traversable`. The result of folding may only be a supertype of this parallel collection's type parameter `T`.

    U

      a type parameter for the binary operator, a supertype of `T`.

    z

      a neutral element for the fold operation, it may be added to the result an arbitrary number of times, not changing the result (e.g. `Nil` for list concatenation, 0 for addition, or 1 for multiplication)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      ParIterableLike → GenTraversableOnce

40. #### def foldLeft[S](z: S)(op: (S, T) ⇒ S): S

    Applies a binary operator to a start value and all elements of this general iterable collection , going left to right.

    Applies a binary operator to a start value and all elements of this general iterable collection , going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this general iterable collection , going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this general iterable collection .

    Definition Classes
      ParIterableLike → GenTraversableOnce

41. #### def foldRight[S](z: S)(op: (T, S) ⇒ S): S

    Applies a binary operator to all elements of this general iterable collection and a start value, going right to left.

    Applies a binary operator to all elements of this general iterable collection and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this general iterable collection , going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this general iterable collection .

    Definition Classes
      ParIterableLike → GenTraversableOnce

42. #### def forall(pred: (T) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this general iterable collection .

    Tests whether a predicate holds for all elements of this general iterable collection .

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    returns

      true if `p` holds for all elements, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

43. #### def foreach[U](f: (T) ⇒ U): Unit

    Applies a function `f` to all the elements of general iterable collection in a sequential order.

    Applies a function `f` to all the elements of general iterable collection in a sequential order.

    U

      the result type of the function applied to each element, which is always discarded

    f

      function applied to each element

    Definition Classes
      ParIterableLike → GenTraversableLike → GenTraversableOnce

44. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

45. #### def groupBy[K](f: (T) ⇒ K): ParMap[K, Repr]

    Partitions this general iterable collection into a map of general iterable collection s according to some discriminator function.

    Partitions this general iterable collection into a map of general iterable collection s according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new general iterable collection .

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to general iterable collection s such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a general iterable collection of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      ParIterableLike → GenTraversableLike

46. #### def hasDefiniteSize: Boolean

    Definition Classes
      ParIterableLike → GenTraversableOnce

47. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

48. #### def head: T

    Definition Classes
      GenIterableLike → GenTraversableLike

49. #### def isEmpty: Boolean

    Tests whether the general iterable collection is empty.

    Tests whether the general iterable collection is empty.

    returns

      `true` if the general iterable collection contains no elements, `false` otherwise.

    Definition Classes
      GenIterableLike → GenTraversableOnce

50. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

51. #### def isStrictSplitterCollection: Boolean

    Denotes whether this parallel collection has strict splitters.

    Denotes whether this parallel collection has strict splitters.

    This is true in general, and specific collection instances may choose to override this method. Such collections will fail to execute methods which rely on splitters being strict, i.e. returning a correct value in the `remaining` method.

    This method helps ensure that such failures occur on method invocations, rather than later on and in unpredictable ways.

52. #### final def isTraversableAgain: Boolean

    Tests whether this general iterable collection can be repeatedly traversed.

    Tests whether this general iterable collection can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

53. #### def iterator: Splitter[T]

    Creates a new split iterator used to traverse the elements of this collection.

    Creates a new split iterator used to traverse the elements of this collection.

    By default, this method is implemented in terms of the protected `splitter` method.

    returns

      a split iterator

    Definition Classes
      ParIterableLike → GenIterableLike

54. #### abstract def map[B](f: (T) ⇒ B): GenIterable[B]

    [use case] Builds a new collection by applying a function to all elements of this general iterable collection .

    [use case]

    Builds a new collection by applying a function to all elements of this general iterable collection .

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this general iterable collection and collecting the results.

    Definition Classes
      GenTraversableLike

55. #### def map[S, That](f: (T) ⇒ S)(implicit bf: CanBuildFrom[Repr, S, That]): That

    Builds a new collection by applying a function to all elements of this general iterable collection .

    Builds a new collection by applying a function to all elements of this general iterable collection .

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this general iterable collection and collecting the results.

    Definition Classes
      ParIterableLike → GenTraversableLike

56. #### abstract def max: T

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this general iterable collection with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

57. #### def max[U >: T](implicit ord: Ordering[U]): T

    Finds the largest element.

    Finds the largest element.

    returns

      the largest element of this general iterable collection with respect to the ordering `cmp`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

58. #### def maxBy[S](f: (T) ⇒ S)(implicit cmp: Ordering[S]): T

    Definition Classes
      ParIterableLike → GenTraversableOnce

59. #### abstract def min: T

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this general iterable collection with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

60. #### def min[U >: T](implicit ord: Ordering[U]): T

    Finds the smallest element.

    Finds the smallest element.

    returns

      the smallest element of this general iterable collection with respect to the ordering `cmp`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

61. #### def minBy[S](f: (T) ⇒ S)(implicit cmp: Ordering[S]): T

    Definition Classes
      ParIterableLike → GenTraversableOnce

62. #### def mkString: String

    Displays all elements of this general iterable collection in a string.

    Displays all elements of this general iterable collection in a string.

    returns

      a string representation of this general iterable collection . In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this general iterable collection follow each other without any separator string.

    Definition Classes
      ParIterableLike → GenTraversableOnce

63. #### def mkString(sep: String): String

    Displays all elements of this general iterable collection in a string using a separator string.

    Displays all elements of this general iterable collection in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this general iterable collection . In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this general iterable collection are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

64. #### def mkString(start: String, sep: String, end: String): String

    Displays all elements of this general iterable collection in a string using start, end, and separator strings.

    Displays all elements of this general iterable collection in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this general iterable collection . The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this general iterable collection are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

65. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

66. #### def nonEmpty: Boolean

    Tests whether the general iterable collection is not empty.

    Tests whether the general iterable collection is not empty.

    returns

      `true` if the general iterable collection contains at least one element, `false` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

67. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

68. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

69. #### def par: Repr

    Returns a parallel implementation of this collection.

    Returns a parallel implementation of this collection.

    For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

    Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

    All parallel collections return a reference to themselves.

    returns

      a parallel implementation of this collection

    Definition Classes
      ParIterableLike → CustomParallelizable → Parallelizable

70. #### def parCombiner: Combiner[T, Repr]

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    returns

      a combiner for the parallel collection of type `ParRepr`

    Attributes
      protected[this]
    Definition Classes
      CustomParallelizable → Parallelizable

71. #### def partition(pred: (T) ⇒ Boolean): (Repr, Repr)

    Partitions this general iterable collection in two general iterable collection s according to a predicate.

    Partitions this general iterable collection in two general iterable collection s according to a predicate.

    returns

      a pair of general iterable collection s: the first general iterable collection consists of all elements that satisfy the predicate `p` and the second general iterable collection consists of all elements that don't. The relative order of the elements in the resulting general iterable collection s may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

72. #### abstract def product: T

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements of this general iterable collection with respect to the `*` operator in `num`.

    Definition Classes
      GenTraversableOnce

73. #### def product[U >: T](implicit num: Numeric[U]): U

    Multiplies up the elements of this collection.

    Multiplies up the elements of this collection.

    num

      an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

    returns

      the product of all elements of this general iterable collection with respect to the `*` operator in `num`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

74. #### def reduce[U >: T](op: (U, U) ⇒ U): U

    Reduces the elements of this sequence using the specified associative binary operator.

    Reduces the elements of this sequence using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    Note this method has a different signature than the `reduceLeft` and `reduceRight` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

    U

      A type parameter for the binary operator, a supertype of `T`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the collection is nonempty.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Exceptions thrown
      UnsupportedOperationException

      if this general iterable collection is empty.

75. #### def reduceLeft[U >: T](op: (U, T) ⇒ U): U

76. #### def reduceLeftOption[U >: T](op: (U, T) ⇒ U): Option[U]

    Optionally applies a binary operator to all elements of this general iterable collection , going left to right.

    Optionally applies a binary operator to all elements of this general iterable collection , going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` is this general iterable collection is nonempty, `None` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

77. #### def reduceOption[U >: T](op: (U, U) ⇒ U): Option[U]

    Optionally reduces the elements of this sequence using the specified associative binary operator.

    Optionally reduces the elements of this sequence using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    Note this method has a different signature than the `reduceLeftOption` and `reduceRightOption` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

    U

      A type parameter for the binary operator, a supertype of `T`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

78. #### def reduceRight[U >: T](op: (T, U) ⇒ U): U

    Applies a binary operator to all elements of this general iterable collection , going right to left.

    Applies a binary operator to all elements of this general iterable collection , going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this general iterable collection , going right to left:

                      op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

      where `x1, ..., xn` are the elements of this general iterable collection .

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Exceptions thrown
      `UnsupportedOperationException`

      if this general iterable collection is empty.

79. #### def reduceRightOption[U >: T](op: (T, U) ⇒ U): Option[U]

    Optionally applies a binary operator to all elements of this general iterable collection , going right to left.

    Optionally applies a binary operator to all elements of this general iterable collection , going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` is this general iterable collection is nonempty, `None` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

80. #### def repr: Repr

    Definition Classes
      ParIterableLike → GenTraversableLike

81. #### def reuse[S, That](oldc: Option[Combiner[S, That]], newc: Combiner[S, That]): Combiner[S, That]

    Optionally reuses an existing combiner for better performance.

    Optionally reuses an existing combiner for better performance. By default it doesn't - subclasses may override this behaviour. The provided combiner `oldc` that can potentially be reused will be either some combiner from the previous computational task, or `None` if there was no previous phase (in which case this method must return `newc`).

    oldc

      The combiner that is the result of the previous task, or `None` if there was no previous task.

    newc

      The new, empty combiner that can be used.

    returns

      Either `newc` or `oldc`.

    Attributes
      protected

82. #### abstract def sameElements(that: GenIterable[T]): Boolean

    [use case] Checks if the other iterable collection contains the same elements in the same order as this general iterable collection .

    [use case]

    Checks if the other iterable collection contains the same elements in the same order as this general iterable collection .

    that

      the collection to compare with.

    returns

      `true`, if both collections contain the same elements in the same order, `false` otherwise.

    Definition Classes
      GenIterableLike

83. #### def sameElements[U >: T](that: GenIterable[U]): Boolean

    Checks if the other iterable collection contains the same elements in the same order as this general iterable collection .

    Checks if the other iterable collection contains the same elements in the same order as this general iterable collection .

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    Note: will not terminate for infinite-sized collections.

    that

      the collection to compare with.

    returns

      `true`, if both collections contain the same elements in the same order, `false` otherwise.

    Definition Classes
      ParIterableLike → GenIterableLike

84. #### abstract def scan(z: T)(op: (T, T) ⇒ T): GenIterable[T]

    [use case] Computes a prefix scan of the elements of the collection.

    [use case]

    Computes a prefix scan of the elements of the collection.

    z

      neutral element for the operator `op`

    op

      the associative operator for the scan

    returns

      a collection containing the prefix scan of the elements in the original collection

85. #### def scan[U >: T, That](z: U)(op: (U, U) ⇒ U)(implicit bf: CanBuildFrom[Repr, U, That]): That

    Computes a prefix scan of the elements of the collection.

    Computes a prefix scan of the elements of the collection.

    Note: The neutral element `z` may be applied more than once.

    U

      element type of the resulting collection

    That

      type of the resulting collection

    z

      neutral element for the operator `op`

    op

      the associative operator for the scan

    returns

      a collection containing the prefix scan of the elements in the original collection

    Definition Classes
      ParIterableLike → GenTraversableLike

86. #### def scanBlockSize: Int

    Attributes
      protected[this]

87. #### def scanLeft[S, That](z: S)(op: (S, T) ⇒ S)(implicit bf: CanBuildFrom[Repr, S, That]): That

    Produces a collection containing cummulative results of applying the operator going left to right.

    Produces a collection containing cummulative results of applying the operator going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    That

      the actual type of the resulting collection

    z

      the initial value

    op

      the binary operator applied to the intermediate result and the element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      collection with intermediate results

    Definition Classes
      ParIterableLike → GenTraversableLike

88. #### def scanRight[S, That](z: S)(op: (T, S) ⇒ S)(implicit bf: CanBuildFrom[Repr, S, That]): That

    Produces a collection containing cummulative results of applying the operator going right to left.

    Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    Example:

           List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

    That

      the actual type of the resulting collection

    z

      the initial value

    op

      the binary operator applied to the intermediate result and the element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      collection with intermediate results

    Definition Classes
      ParIterableLike → GenTraversableLike

89. #### def sequentially[S, That <: Parallel](b: (Sequential) ⇒ Parallelizable[S, That]): Repr

    Attributes
      protected[this]

90. #### def slice(unc_from: Int, unc_until: Int): Repr

    Selects an interval of elements.

    Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

           from <= indexOf(x) < until

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a general iterable collection containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this general iterable collection .

    Definition Classes
      ParIterableLike → GenTraversableLike

91. #### def span(pred: (T) ⇒ Boolean): (Repr, Repr)

    Splits this general iterable collection into a prefix/suffix pair according to a predicate.

    Splits this general iterable collection into a prefix/suffix pair according to a predicate.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

    pred

      the predicate used to test the elements

    returns

      a pair consisting of the longest prefix of the collection for which all the elements satisfy `pred`, and the rest of the collection

    Definition Classes
      ParIterableLike → GenTraversableLike

92. #### def splitAt(n: Int): (Repr, Repr)

    Splits this general iterable collection into two at a given position.

    Splits this general iterable collection into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the position at which to split.

    returns

      a pair of general iterable collection s consisting of the first `n` elements of this general iterable collection , and the other elements.

    Definition Classes
      ParIterableLike → GenTraversableLike

93. #### abstract def sum: T

    [use case] Sums up the elements of this collection.

    [use case]

    Sums up the elements of this collection.

    returns

      the sum of all elements of this general iterable collection with respect to the `+` operator in `num`.

    Definition Classes
      GenTraversableOnce

94. #### def sum[U >: T](implicit num: Numeric[U]): U

    Sums up the elements of this collection.

    Sums up the elements of this collection.

    num

      an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

    returns

      the sum of all elements of this general iterable collection with respect to the `+` operator in `num`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

95. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

96. #### def tail: Repr

    Selects all elements except the first.

    Selects all elements except the first.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a general iterable collection consisting of all elements of this general iterable collection

      except the first one.

    Definition Classes
      GenTraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the general iterable collection is empty.

97. #### def take(n: Int): Repr

    Selects first n elements.

    Selects first n elements.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      Tt number of elements to take from this general iterable collection .

    returns

      a general iterable collection consisting only of the first `n` elements of this general iterable collection , or else the whole general iterable collection , if it has less than `n` elements.

    Definition Classes
      ParIterableLike → GenTraversableLike

98. #### def takeWhile(pred: (T) ⇒ Boolean): Repr

    Takes the longest prefix of elements that satisfy the predicate.

    Takes the longest prefix of elements that satisfy the predicate.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

    pred

      the predicate used to test the elements

    returns

      the longest prefix of this general iterable collection of elements that satisy the predicate `pred`

    Definition Classes
      ParIterableLike → GenTraversableLike

99. #### implicit def task2ops[R, Tp](tsk: SSCTask[R, Tp]): TaskOps[R, Tp]

    Attributes
      protected

100. #### def threshold(sz: Int, p: Int): Int

     Some minimal number of elements after which this collection should be handled sequentially by different processors.

     Some minimal number of elements after which this collection should be handled sequentially by different processors.

     This method depends on the size of the collection and the parallelism level, which are both specified as arguments.

     sz

       the size based on which to compute the threshold

     p

       the parallelism level based on which to compute the threshold

     returns

       the maximum number of elements for performing operations sequentially

101. #### abstract def toArray: Array[T]

     [use case] Converts this general iterable collection to an array.

     [use case]

     Converts this general iterable collection to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this general iterable collection .

     Definition Classes
       GenTraversableOnce

102. #### def toArray[U >: T](implicit arg0: ClassManifest[U]): Array[U]

     Converts this general iterable collection to an array.

     Converts this general iterable collection to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this general iterable collection .

     Definition Classes
       ParIterableLike → GenTraversableOnce

103. #### def toBuffer[U >: T]: Buffer[U]

     Converts this general iterable collection to a mutable buffer.

     Converts this general iterable collection to a mutable buffer.

     Note: will not terminate for infinite-sized collections.

     returns

       a buffer containing all elements of this general iterable collection .

     Definition Classes
       ParIterableLike → GenTraversableOnce

104. #### def toIndexedSeq[U >: T]: IndexedSeq[U]

     Converts this general iterable collection to an indexed sequence.

     Converts this general iterable collection to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this general iterable collection .

     Definition Classes
       ParIterableLike → GenTraversableOnce

105. #### def toIterable: ParIterable[T]

     Converts this general iterable collection to an iterable collection.

     Converts this general iterable collection to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this general iterable collection .

     Definition Classes
       ParIterableLike → GenTraversableOnce

106. #### def toIterator: Iterator[T]

     Returns an Iterator over the elements in this general iterable collection .

     Returns an Iterator over the elements in this general iterable collection . Will return the same Iterator if this instance is already an Iterator.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this general iterable collection .

     Definition Classes
       ParIterableLike → GenTraversableOnce

107. #### def toList: List[T]

     Converts this general iterable collection to a list.

     Converts this general iterable collection to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this general iterable collection .

     Definition Classes
       ParIterableLike → GenTraversableOnce

108. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this general iterable collection to a map.

     [use case]

     Converts this general iterable collection to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this general iterable collection .

     Definition Classes
       GenTraversableOnce

109. #### def toMap[K, V](implicit ev: <:<[T, (K, V)]): ParMap[K, V]

     Converts this general iterable collection to a map.

     Converts this general iterable collection to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this general iterable collection .

     Definition Classes
       ParIterableLike → GenTraversableOnce

110. #### def toParCollection[U >: T, That](cbf: () ⇒ Combiner[U, That]): That

     Attributes
       protected

111. #### def toParMap[K, V, That](cbf: () ⇒ Combiner[(K, V), That])(implicit ev: <:<[T, (K, V)]): That

     Attributes
       protected

112. #### def toSeq: ParSeq[T]

     Converts this general iterable collection to a sequence.

     Converts this general iterable collection to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     Note: will not terminate for infinite-sized collections.

     returns

       a sequence containing all elements of this general iterable collection .

     Definition Classes
       ParIterableLike → GenTraversableOnce

113. #### def toSet[U >: T]: ParSet[U]

     Converts this general iterable collection to a set.

     Converts this general iterable collection to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this general iterable collection .

     Definition Classes
       ParIterableLike → GenTraversableOnce

114. #### def toStream: Stream[T]

     Converts this general iterable collection to a stream.

     Converts this general iterable collection to a stream.

     Note: will not terminate for infinite-sized collections.

     returns

       a stream containing all elements of this general iterable collection .

     Definition Classes
       ParIterableLike → GenTraversableOnce

115. #### def toString(): String

     Creates a String representation of this object.

     Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

     returns

       a String representation of the object.

     Definition Classes
       ParIterableLike → AnyRef → Any

116. #### def toTraversable: GenTraversable[T]

     Converts this general iterable collection to an unspecified Traversable.

     Converts this general iterable collection to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this general iterable collection .

     Definition Classes
       ParIterableLike → GenTraversableOnce

117. #### def view: ParIterableView[T, Repr, Sequential]

118. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

119. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

120. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

121. #### def wrap[R](body: ⇒ R): NonDivisible[R]

     Attributes
       protected

122. #### abstract def zip[B](that: GenIterable[B]): GenIterable[(T, B)]

     [use case] Returns a general iterable collection formed from this general iterable collection and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a general iterable collection formed from this general iterable collection and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this general iterable collection and `that`. The length of the returned collection is the minimum of the lengths of this general iterable collection and `that`.

     Definition Classes
       GenIterableLike

123. #### def zip[U >: T, S, That](that: GenIterable[S])(implicit bf: CanBuildFrom[Repr, (U, S), That]): That

     Returns a general iterable collection formed from this general iterable collection and another iterable collection by combining corresponding elements in pairs.

     Returns a general iterable collection formed from this general iterable collection and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this general iterable collection and `that`. The length of the returned collection is the minimum of the lengths of this general iterable collection and `that`.

     Definition Classes
       ParIterableLike → GenIterableLike

124. #### abstract def zipAll[B](that: Iterable[B], thisElem: T, thatElem: B): GenIterable[(T, B)]

     [use case] Returns a general iterable collection formed from this general iterable collection and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a general iterable collection formed from this general iterable collection and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this general iterable collection is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this general iterable collection .

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this general iterable collection and `that`. The length of the returned collection is the maximum of the lengths of this general iterable collection and `that`. If this general iterable collection is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this general iterable collection , `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

125. #### def zipAll[S, U >: T, That](that: GenIterable[S], thisElem: U, thatElem: S)(implicit bf: CanBuildFrom[Repr, (U, S), That]): That

     Returns a general iterable collection formed from this general iterable collection and another iterable collection by combining corresponding elements in pairs.

     Returns a general iterable collection formed from this general iterable collection and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this general iterable collection is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this general iterable collection .

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this general iterable collection and `that`. The length of the returned collection is the maximum of the lengths of this general iterable collection and `that`. If this general iterable collection is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this general iterable collection , `thatElem` values are used to pad the result.

     Definition Classes
       ParIterableLike → GenIterableLike

126. #### abstract def zipWithIndex: GenIterable[(T, Int)]

     [use case] Zips this general iterable collection with its indices.

     [use case]

     Zips this general iterable collection with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this general iterable collection paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

127. #### def zipWithIndex[U >: T, That](implicit bf: CanBuildFrom[Repr, (U, Int), That]): That

     Zips this general iterable collection with its indices.

     Zips this general iterable collection with its indices.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this general iterable collection paired with their index. Indices start at `0`.

     Definition Classes
       ParIterableLike → GenIterableLike

### Inherited from HasNewCombiner[T, Repr]

### Inherited from Parallel

### Inherited from CustomParallelizable[T, Repr]

### Inherited from GenIterableLike[T, Repr]

### Inherited from GenTraversableLike[T, Repr]

### Inherited from Parallelizable[T, Repr]

### Inherited from GenTraversableOnce[T]

### Inherited from AnyRef

### Inherited from Any